"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeLinearGradient = _interopRequireDefault(require("react-native-linear-gradient"));
var _styles = _interopRequireDefault(require("./styles"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const Shimmer = _ref => {
  let {
    width,
    height,
    borderRadius = 0,
    marginVertical = 0,
    marginHorizontal = 0,
    marginTop = 0,
    marginBottom = 0,
    marginLeft = 0,
    marginRight = 0,
    colors = ['#E6E6E6', '#f5f5f5', '#f5f5f5', '#E6E6E6'],
    duration = 1500,
    islooped = true,
    isReversed = false,
    customStyle,
    children,
    LinearGradientComponent = _reactNativeLinearGradient.default
  } = _ref;
  const LinearGradientAnim = _reactNative.Animated.createAnimatedComponent(LinearGradientComponent);
  const value = (0, _react.useRef)(new _reactNative.Animated.Value(0)).current;
  const animation = _reactNative.Animated.timing(value, {
    toValue: 1,
    duration,
    useNativeDriver: true,
    easing: _reactNative.Easing.linear
  });
  (0, _react.useEffect)(() => {
    islooped ? _reactNative.Animated.loop(animation).start() : animation.start();
  }, [animation, islooped]);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [_styles.default.container(width, height, borderRadius, marginVertical, marginHorizontal, marginTop, marginBottom, marginLeft, marginRight, colors), customStyle]
  }, /*#__PURE__*/_react.default.createElement(LinearGradientAnim, {
    start: {
      x: 0,
      y: 0
    },
    end: {
      x: 1,
      y: 0
    },
    colors: colors,
    style: {
      ..._reactNative.StyleSheet.absoluteFillObject,
      transform: [{
        translateX: value.interpolate({
          inputRange: [0, 1],
          outputRange: isReversed ? [width, -width] : [-width, width]
        })
      }]
    }
  }), /*#__PURE__*/_react.default.createElement(_reactNative.View, null, children));
};
var _default = Shimmer;
exports.default = _default;
//# sourceMappingURL=index.js.map